<?php
/**
 * @package     Joomla.Site
 * @subpackage  com_contact
 *
 * @copyright   (C) 2017 Open Source Matters, Inc. <https://www.joomla.org>
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

namespace Joomla\Component\Debate\Site\Helper;

\defined('_JEXEC') or die;

use Joomla\CMS\Categories\CategoryNode;
use Joomla\CMS\Language\Multilanguage;

/**
 * Contact Component Route Helper
 *
 * @static
 * @package     Joomla.Site
 * @subpackage  com_contact
 * @since       1.5
 */
abstract class RouteHelper
{
		public static function getResponseRoute($id, $catid, $threadid=null, $userid=null, $title=null, $firstid = null  )
	{
				 		

		$link = 'index.php?option=com_debate&view=response&id=' . $id;

		if ((int) $catid > 1)
		{
			$link .= '&catid=' . $catid;
		}
		
		
		if ( !empty($threadid))
		{
			$link .= '&threadid=' . $threadid;
		}
		
		
		if (!empty($userid))
		{
			$link .= '&userid=' . $userid;
		}
	

	
		if (!empty($title))
		{
			$link .= '&title=' . $title;
		}
	

		if (!empty($firstid))
		{
			$link .= '&firstid=' . $firstid;
		}
	
	

		return $link;
	}

	
	public static function getMessageRoute($id, $catid)
	{
				 		

		$link = 'index.php?option=com_debate&view=message&id=' . $id ;

		if ((int) $catid > 1)
		{
			$link .= '&catid=' . $catid;
		}
	
		return $link;
	}
	public static function getFonderRoute($id)
	{
		
			$id = (int) $id;
		

		if ($id < 1)
		{
			$link = '';
		}
		else
		{
			$link = 'index.php?option=com_debate&view=fonder&id=' . $id;
		}

		return $link;
	}
	public static function getUserRoute($id)
	{
		
			$id = (int) $id;
		

		if ($id < 1)
		{
			$link = '';
		}
		else
		{
			$link = 'index.php?option=com_debate&view=user&id=' . $id;
		}

		return $link;
	}
	public static function getTitleRoute($title)
	{	
			$link = 'index.php?option=com_debate&view=chtitle&format=json&title=' . $title;		

		return $link;
	}
	public static function getDepriveRoute()
	{				
		$link = 'index.php?option=com_debate&view=deprive';
		return $link;
	}
	public static function getCategoryRoute($catid)
	{
		if ($catid instanceof JCategoryNode)
		{
			$id = $catid->id;
		}
		else
		{
			$id = (int) $catid;
		}

		if ($id < 1)
		{
			$link = '';
		}
		else
		{
			$link = 'index.php?option=com_debate&view=category&id=' . $id;
		}

		return $link;
	}
	//no parent id in model categories will be fixed. level 1
	public static function getCategoriesRoute()
	{
		
			$link = 'index.php?option=com_debate&view=categories';
		

		return $link;
	}
}
